; 
    include \masm32\include\masm32rt.inc
    .686
    include timers.asm

    cmpmem_incdec PROTO :DWORD,:DWORD,:DWORD
    szRev_incdec  PROTO :DWORD,:DWORD
    szWcnt_incdec PROTO :DWORD,:DWORD

; 
    .data
      pMem dd 0
      fLen dd 0
      teststr db "Instead of comparing code sequences of a type that ",\
                 "that are not representative of real code, this app ",\
                 "compares two versions each of several of the MASM32 ",\
                 "library procedures.",0
      buffer2 db SIZEOF teststr dup(0)
    .code
; 
start:
; 
    invoke read_disk_file, chr$("\masm32\m32lib\cmpmem.asm"),
                          ADDR pMem, ADDR fLen
    ;print ustr$(fLen)," bytes",13,10

    ;invoke cmpmem, pMem, pMem, fLen
    ;print ustr$(eax),13,10
    ;invoke cmpmem_incdec, pMem, pMem, fLen
    ;print ustr$(eax),13,10

    LOOP_COUNT equ 1000000

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      invoke cmpmem, pMem, pMem, fLen
    counter_end
    print ustr$(eax)," cycles, cmpmem",13,10

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      invoke cmpmem_incdec, pMem, pMem, fLen
    counter_end
    print ustr$(eax)," cycles, cmpmem_incdec",13,10

    free pMem

    ;invoke szRev,ADDR teststr,ADDR teststr
    ;print ADDR teststr,13,10
    ;invoke szRev_incdec,ADDR teststr,ADDR teststr
    ;print ADDR teststr,13,10

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      invoke szRev,ADDR teststr,ADDR buffer2
    counter_end
    print ustr$(eax)," cycles, szRev",13,10

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      invoke szRev_incdec,ADDR teststr,ADDR buffer2
    counter_end
    print ustr$(eax)," cycles, szRev_incdec",13,10

    ;invoke szWcnt,ADDR teststr,chr$("of")
    ;print ustr$(eax),13,10
    ;invoke szWcnt_incdec,ADDR teststr,chr$("of")
    ;print ustr$(eax),13,10

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      invoke szWcnt,ADDR teststr,chr$("of")
    counter_end
    print ustr$(eax)," cycles, szWcnt",13,10

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      invoke szWcnt_incdec,ADDR teststr,chr$("of")
    counter_end
    print ustr$(eax)," cycles, szWcnt_incdec",13,10

    inkey "Press any key to exit..."
    exit
; 

align 4

cmpmem_incdec proc buf1:DWORD,buf2:DWORD,bcnt:DWORD

    push esi
    push edi

    mov edx, bcnt
    shr edx, 2                      ; div by 4

    mov esi, buf1
    mov edi, buf2
    xor ecx, ecx

  align 4
  @@:
    mov eax, [esi+ecx]              ; DWORD compare main file
    cmp eax, [edi+ecx]
    jne fail
    add ecx, 4
    ;sub edx, 1
    DEC EDX
    jnz @B

    mov edx, bcnt                   ; calculate any remainder
    and edx, 3
    jz match                        ; exit if its zero
    xor eax, eax                    ; clear EAX for partial writes

  @@:
    mov al, [esi+ecx]               ; BYTE compare tail
    cmp al, [edi+ecx]
    jne fail
    ;add ecx, 1
    INC ECX
    ;sub edx, 1
    DEC EDX
    jnz @B

    jmp match

  fail:
    xor eax, eax                    ; return zero if DIFFERENT
    jmp quit

  match:
    mov eax, 1                      ; return NON zero if SAME

  quit:
    pop edi
    pop esi

    ret

cmpmem_incdec endp

; 

align 4

szRev_incdec proc src:DWORD,dst:DWORD

  ; ------------------------------------
  ; this version will reverses a string
  ; in a single memory buffer so it can
  ; accept the same address as both src
  ; and dst.
  ; ------------------------------------

    push esi
    push edi

    mov esi, src
    mov edi, dst
    xor eax, eax            ; use EAX as a counter

  ; ---------------------------------------
  ; first loop gets the buffer length and
  ; copies the first buffer into the second
  ; ---------------------------------------
  @@:
    mov dl, [esi+eax]       ; copy source to dest
    mov [edi+eax], dl
    ;add eax, 1              ; get the length in ECX
    INC EAX
    test dl, dl
    jne @B

    mov esi, dst            ; put dest address in ESI
    mov edi, dst            ; same in EDI
    ;sub eax, 1              ; correct for exit from 1st loop
    DEC EAX
    
    lea edi, [edi+eax-1]    ; end address in edi
    shr eax, 1              ; int divide length by 2
    neg eax                 ; invert sign
    sub esi, eax            ; sub half len from ESI

  ; ------------------------------------------
  ; second loop swaps end pairs of bytes until
  ; it reaches the middle of the buffer
  ; ------------------------------------------
  @@:
    mov cl, [esi+eax]       ; load end pairs
    mov dl, [edi]
    mov [esi+eax], dl       ; swap end pairs
    mov [edi], cl
    ;sub edi, 1
    DEC EDI
    ;add eax, 1
    INC EAX
    jnz @B                  ; exit on half length

    mov eax, dst            ; return destination address

    pop edi
    pop esi

    ret

szRev_incdec endp

; 

align 4

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

szWcnt_incdec proc src:DWORD,txt:DWORD

    push ebx
    push esi
    push edi

    mov edx, len([esp+16])      ; procedure call for src length
    sub edx, len([esp+20])      ; procedure call for 1st text length

    mov eax, -1
    mov esi, [esp+16]           ; source in ESI
    add edx, esi                ; add src to exit position
    xor ebx, ebx                ; clear EBX to prevent stall with BL
    ;add edx, 1                  ; correct to get last word
    INC EDX
    mov edi, [esp+20]           ; text to count in EDI
    ;sub esi, 1
    DEC ESI
  pre:
    ;add eax, 1                  ; increment word count return value
    INC EAX
  align 4
  wcst:
    ;add esi, 1
    INC ESI
    cmp edx, esi                ; test for exit condition
    jle wcout
    mov bl, [esi]               ; load byte at ESI
    cmp bl, [edi]               ; test against 1st character in EDI
    jne wcst
    xor ecx, ecx
  align 4
  test_word:
    ;add ecx, 1
    INC ECX
    cmp BYTE PTR [edi+ecx], 0   ; if terminator is reached
    je pre                      ; jump back and increment counter
    mov bl, [esi+ecx]           ; load byte at ESI
    cmp bl, [edi+ecx]           ; test against 1st character in EDI
    jne wcst                    ; exit if mismatch
    jmp test_word               ; else loop back
  wcout:

    pop edi
    pop esi
    pop ebx

    ret 8

szWcnt_incdec endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

end start
 